<?php
include_once "../../conf/include.inc.php";
include_once "locale.inc.php";
include_once "filter.inc.php";
include_once "prefs.inc.php";
include_once "auth.inc.php";

$errorPage = "admin.html";
$gMSG = "";

$confname = "config.inc.php";
$lines = @file("../../conf/$confname");
$changed = false;
$error = false;
$ctxt = array();

if (isset($_REQUEST['submit'])) {
	if (CheckParm($gFilter_email,"from",_("Emetteur du message (champ From:)"),$from))
		$error = true;

	if (CheckParm($gFilter_digit,"ttime",_("Dur&eacute;e de validit&eacute; du ticket"),$ttime))
		$error = true;

	if (CheckParm($gFilter_url,"phppath",_("Chemin de l'interpr&eacute;teur PHP"),$phppath))
		$error = true;

	if (!$error && !@file_exists("$phppath")) {
		$gMSG = _('L\'interpr&eacute;teur \'$phppath\' n\'existe pas');
		$gMSG = preg_replace('/\$phppath/',$phppath,$gMSG);
		$error = true;
	}

	if (CheckParm($gFilter_url,"baseurl",_("URL de base du site"),$sitename)) 
		$error = true;

	if (!isset($_REQUEST['enctext']) && !isset($_REQUEST['enchtml'])) {
		$gMSG = _("Au moins un des deux types d'encodage doit &ecirc;tre s&eacute;lectionn&eacute;");
		$error = true;
	}

	foreach ($gUsrLangSupported as $lang) {
		if (!$gShowLang && $lang != $gUsrLangDefault) continue;

		if (CheckParm($gFilter_any,"subject_$lang",_("Sujet du message pour la langue '$lang'"),$admlang)) {
			$error = true;
			break;
		}

		if (isset($_REQUEST['enctext'])) {
			if (!isset($_REQUEST["fictext_$lang"])) {
				$gMSG = _('Le nom du fichier texte contenant le message pour la langue \'$lang\' est vide');
				$gMSG = preg_replace('/\$lang/',$lang,$gMSG);
				$error = true;
			}
			else {
				$f = $_REQUEST["fictext_$lang"];
				$fname = "$gMessageDir/$lang/$f";
				if (!@file_exists("$fname")) {
					$gMSG = _("Le fichier \$lang/\$f n'existe pas");
					$gMSG = preg_replace('/\$lang/',$lang,$gMSG);
					$gMSG = preg_replace('/\$f/',$f,$gMSG);
					$error = true;
				}
				else {
					# Check for %L% macros:
					$content = file_get_contents("$fname");
					if (!strpos($content,"%L%")) {
						$gMSG = _('Le message \'$fname\' ne contient pas la macro \'%L%\' (lien vers le ticket)');
						$gMSG = preg_replace('/\$fname/',$fname,$gMSG);
						$error = true;
					}
				}
			}
		}

		if (isset($_REQUEST['enchtml'])) {
			if ( !isset($_REQUEST["fichtml_$lang"])) {
				$gMSG = _('Le nom du fichier HTML contenant le message pour la langue \'$lang\' est vide');
				$gMSG = preg_replace('/\$lang/',$lang,$gMSG);
				$error = true;
			}
			else {
				$f = $_REQUEST["fichtml_$lang"];
				$fname = "$gMessageDir/$lang/$f";
				if (!@file_exists("$fname")) {
					$gMSG = _("Le fichier \$lang/\$f n'existe pas");
					$gMSG = preg_replace('/\$lang/',$lang,$gMSG);
					$gMSG = preg_replace('/\$f/',$f,$gMSG);
					$error = true;
				}
				else {
					# Check for %L% macros:
					$content = file_get_contents("$fname");
					if (!strpos($content,"%L%")) {
						$gMSG = _('Le message \'$fname\' ne contient pas la macro \'%L%\' (lien vers le ticket)');
						$gMSG = preg_replace('/\$fname/',$fname,$gMSG);
						$error = true;
					}
				}
			}
		}
	}

	$enctext = (isset($_REQUEST['enctext'])) ? "true" : "false";
	$enchtml = (isset($_REQUEST['enchtml'])) ? "true" : "false";

	if (!$error) {
		$lines = preg_replace('/^(\$gAdmEmail.*=.*")(.*)(".*)/',"\${1}".$from.'\3',$lines);
		$lines = preg_replace('/^(\$gMessageTEXTEncoding.*= )(.*)(;.*)/',"\${1}".$enctext.'\3',$lines);
		$lines = preg_replace('/^(\$gMessageHTMLEncoding.*= )(.*)(;.*)/',"\${1}".$enchtml.'\3',$lines);
		$lines = preg_replace('/^(\$gTicketLifeTime.*=.*")(.*)(".*)/',"\${1}".$ttime.'\3',$lines);
		$lines = preg_replace('/^(\$gPHPPath.*=.*")(.*)(".*)/',"\${1}".$phppath.'\3',$lines);
		$lines = preg_replace('/^(\$gSiteName.*=.*")(.*)(".*)/',"\${1}".$sitename.'\3',$lines);

		foreach ($gUsrLangSupported as $lang) {
			$lines = preg_replace('/^(\$gMessageSubject..'.$lang.'.*=.*")(.*)(".*)/',"\${1}".$_REQUEST["subject_$lang"].'\3',$lines);
			$lines = preg_replace('/^(\$gMessageTEXTFile..'.$lang.'.*=.*")(.*)(".*)/',"\${1}".$_REQUEST["fictext_$lang"].'\3',$lines);
			$lines = preg_replace('/^(\$gMessageHTMLFile..'.$lang.'.*=.*")(.*)(".*)/',"\${1}".$_REQUEST["fichtml_$lang"].'\3',$lines);
			$gMessageSubject[$lang] = $_REQUEST["subject_$lang"];
			$gMessageTEXTFile[$lang] = $_REQUEST["fictext_$lang"];
			$gMessageHTMLFile[$lang] = $_REQUEST["fichtml_$lang"];
		}

		$gAdmEmail = $from;
		$gMessageTEXTEncoding = $enctext;
		$gMessageHTMLEncoding = $enchtml;
		$gTicketLifeTime = $ttime;

		$changed = true;
	}
}


if ($changed) {
	UpdateConfFile($confname,$lines);
	
	# save $gMSG !
	$msg = $gMSG;
	include "config.inc.php";
	$gMSG = $msg;
}

# Build the list of available files in the $gMessageDir directories:
foreach ($gUsrLangSupported as $lang) {
	$ctxt[$lang] = array();
	if (!($fd = @opendir("$gMessageDir/$lang"))) {
		$gMSG = _('Impossible d\'ouvrir le r&eacute;pertoire \'$gMessageDir/$lang\'');
		$gMSG = preg_replace('/\$lang/',$lang,$gMSG);
		$gMSG = preg_replace('/\$gMessageDir/',$gMessageDir,$gMSG);
	}
	else {
		while ($file = readdir($fd)) {
			if ($file == "." || $file == "..") continue;
			if (preg_match('/.*\.txt$/',$file))
				$ctxt["text_$lang"][] = $file;
			if (preg_match('/.*\.html$/',$file))
				$ctxt["html_$lang"][] = $file;
		}
		closedir($fd);

		if (!isset($ctxt["text_$lang"])) $ctxt["text_$lang"][] = "";
		if (!isset($ctxt["html_$lang"])) $ctxt["html_$lang"][] = "";

		sort($ctxt["text_$lang"]);
		sort($ctxt["html_$lang"]);
	}
}

#print_r($lines);

include_once "backend.inc.php";

PageAdminOutput("mailprefs.html",$ctxt);
?>
