<?php
# 
# Called by Windows synchttp.exe/syncunlk.dll each time
# a password has been changed.
# If the user is not in the Database, we must add it.
# Attributes are retrieved using LDAP.
#
include_once "../../conf/include.inc.php";
include_once "../common/backend.inc.php";

$gMSG = "OK";

# Check the IP address of client
$allowedIP = array( "127.0.0.1", "192.168.1.71" );

	# Note: if you have protected the admin interface with
	#       Apache directives make sure this script can still
	#	be accessed by the listed IP address

$sharedSecret = "pwunlock31";
	# Do not forget to change the secret and make it equals
	# to the secret used by the Client

if (!in_array($_SERVER['REMOTE_ADDR'],$allowedIP)) {
	$gMSG = _("winuser.php appele par un client illicite");
	BackendLog($_SERVER["REMOTE_ADDR"],ULK_TYPE_ERROR,ULK_ERR_ILLEGALCLIENT,$gMSG);
	die($gMSG);
}

# Just for debug:
system("echo ".$_REQUEST['account']." >> /tmp/synchttp.out");

if (!isset($_REQUEST['account'])) {
	$gMSG = _("winuser.php appele sans parametre 'account'");
	BackendLog($_SERVER["REMOTE_ADDR"],ULK_TYPE_ERROR,ULK_ERR_ACCOUNTMISSING,$gMSG);
	die($gMSG);
}
$account = $_REQUEST['account'];

if (!isset($_REQUEST['hash'])) {
	$gMSG = _("winuser.php appele sans parametre 'hash'");
	BackendLog($_SERVER["REMOTE_ADDR"],ULK_TYPE_ERROR,ULK_ERR_HASHMISSING,$gMSG);
	die($gMSG);
}

# Check the hash value consistency:
if (md5("$account$sharedSecret") != $_REQUEST['hash']) {
	$gMSG = _("winuser.php appele avec une mauvaise valeur de 'hash'");
	BackendLog($_SERVER["REMOTE_ADDR"],ULK_TYPE_ERROR,ULK_ERR_BADHASHVALUE,$gMSG);
	die($gMSG);
}

# Check the user name does not already exists:
if ($usr = BackendGetUserByName($account)) {
	$gMSG = _("Le compte existe deja");
	die($gMSG);
}

# Get other attributes from LDAP (AD):
if (!($lh = ldap_connect($gLDAPHost,$gLDAPPort))) {
	$gMSG = _("Erreur de connexion au serveur LDAP");
	BackendLog($_SERVER["REMOTE_ADDR"],ULK_TYPE_ERROR,ULK_ERR_LDAPERROR,$gMSG);
	die($gMSG);
}

if (!ldap_bind($lh,$gLDAPBindDN,$gLDAPBindPwd)) {
	$gMSG = _("Erreur de liaison au serveur LDAP");
	BackendLog($_SERVER["REMOTE_ADDR"],ULK_TYPE_ERROR,ULK_ERR_LDAPERROR,$gMSG);
	ldap_close($lh);
	die($gMSG);
}

$filter = preg_replace('/\$account/',$account,$gLDAPFilter);
$justthese = array($gLDAPEmailAttr,$gLDAPFullNameAttr);
if (!( $rh = ldap_search($lh,$gLDAPBase,$filter,$justthese))) {
	$gMSG = _("Erreur de recherche dans le serveur LDAP");
	BackendLog($_SERVER["REMOTE_ADDR"],ULK_TYPE_ERROR,ULK_ERR_LDAPERROR,$gMSG);
	ldap_close($lh);
	die($gMSG);
}

if (!($users = ldap_get_entries($lh,$rh))) {
	$gMSG = _("Impossible d'obtenir le resultat de la recherche LDAP");
	BackendLog($_SERVER["REMOTE_ADDR"],ULK_TYPE_ERROR,ULK_ERR_LDAPERROR,$gMSG);
	ldap_close($lh);
	die($gMSG);
}

print_r($users);

$email = $users[0][strtolower($gLDAPEmailAttr)][0];
$fullname = $users[0][strtolower($gLDAPFullNameAttr)][0];
$info = $gLDAPCreateInfo;
$lang = $gLDAPCreateLanguage;
$accountlist = $gLDAPCreateAccount;

ldap_close($lh);

# Call the creation script:
$cmd = "cd ../../scripts/creation; ".$gPHPPath." -q account_create.php -m syncunlk -u \"$account\" -l \"$lang\" -i \"$info\" -e \"$email\" -f \"$fullname\" -a \"$accountlist\" -t";
echo $cmd;
system($cmd);

$msg = _("Compte '\$account' cree par winuser.php");
$msg = preg_replace('/\$account/',$account,$msg);
BackendLog($_SERVER['REMOTE_ADDR'],ULK_TYPE_INFO,ULK_INF_ACCOUNTCREATED,$msg);

echo $gMSG;
?>
