<?php
# Get an instance to the good backend:
# Remember, we avoid classes and objects for a better PHP4/5 portability:

include_once "config.inc.php";
include_once "error.inc.php";
include_once "utils.inc.php";

$errorPage = "notInitialized.html";

# if backend not initialized, send a predefined page back:
if (!$gAdmInitialized) {
	PageAdminOutput($errorPage,$empty);
	die;
}

#if (!@file_exists("backend_$gAdmDBType.inc.php")) {
#	$gMSG = _("Le type de base '$gAdmDBType' n'est pas support&eacute;");
#	PageAdminOutput($errorPage,$empty);
#	die;
#}
include_once "backend_$gAdmDBType.inc.php";

# Connect to the Database and initialize a DB handle:
if (!DBConnect($gAdmDBHost,$gAdmDBName,$gAdmDBUser,$gAdmDBPasswd)) {
	$gMSG = DBLastError();
	PageAdminOutput($errorPage,$empty);
	die;
}

# ---------------------------------------------------------
# Log and Stats Management:
# ---------------------------------------------------------
function BackendAddStat($usr_id,$client,$action,$info)
{
	# Since all the values are inserted by this software
	# we do not filter the parameters, except for the "info":
	$info = addslashes($info);
	$client = ip2long($client);

	$query = "INSERT INTO t_ulk_stat (usr_id,sta_client,sta_date,sta_action,sta_info) ".
			"VALUES ('$usr_id','$client',NOW(),'$action','$info')";

	return DBExecute($query);
}

function BackendGetStat($startdate,$enddate,$client,$cat,$userid)
{
	$startdate = addslashes($startdate);
	$enddate = addslashes($enddate);
	$cat = addslashes($cat);
	$userid = addslashes($userid);

	$filter = "";
	if (!empty($client)) {
		$client = ip2long($client);
		$filter .= "log_client = '$client'";
	}
	if (!empty($startdate)) {
		if (!empty($filter)) $filter .= " AND ";
		$filter .= "sta_date >= '$startdate'";
	}
	if (!empty($enddate)) {
		if (!empty($filter)) $filter .= " AND ";
		$filter .= "sta_date <= '$enddate'";
	}
	if (!empty($userid)) {
		if (!empty($filter)) $filter .= " AND ";
		$filter .= "usr_id = '$userid'";
	}
	if (!empty($cat)) {
		if (!empty($filter)) $filter .= " AND ";
		$filter .= "sta_action = '$cat'";
	}
	if (!empty($filter)) $filter = "WHERE ".$filter;

	$query = "SELECT DATE_FORMAT(sta_date,'%y-%m-%d %H:%i:%s') as sta_date,sta_action,usr_id,sta_client,sta_info ".
			" FROM t_ulk_stat $filter ORDER BY sta_date ASC";
	#echo $query;

	if ($rows = DBQueryAndFetchRows($query)) {
		for ( $idx = 0 ; $idx < count($rows) ; $idx++ ) {
			stripslashes($rows[$idx]['sta_info']);
		}
	}
	
	return $rows;
}

function BackendDelStat($startdate,$enddate,$client,$cat,$userid)
{
	$startdate = addslashes($startdate);
	$enddate = addslashes($enddate);
	$cat = addslashes($cat);
	$userid = addslashes($userid);

	$filter = "";
	if (!empty($client)) {
		$client = ip2long($client);
		$filter .= "log_client = '$client'";
	}
	if (!empty($startdate)) {
		if (!empty($filter)) $filter .= " AND ";
		$filter .= "sta_date >= '$startdate'";
	}
	if (!empty($enddate)) {
		if (!empty($filter)) $filter .= " AND ";
		$filter .= "sta_date <= '$enddate'";
	}
	if (!empty($userid)) {
		if (!empty($filter)) $filter .= " AND ";
		$filter .= "usr_id = '$userid'";
	}
	if (!empty($cat)) {
		if (!empty($filter)) $filter .= " AND ";
		$filter .= "sta_action = '$cat'";
	}
	if (!empty($filter)) $filter = "WHERE ".$filter;

	$query = "DELETE FROM t_ulk_stat $filter";
	#echo $query;

	if (!DBExecute($query))
		return 0;

	return 1;
}

function BackendGetUserStat($usr_id)
{
	$usr_id = addslashes($usr_id);

	$query = "SELECT DATE_FORMAT(sta_date,'%y-%m-%d %H:%i:%s') as sta_date,sta_action,usr_id,sta_client,sta_info ".
			"FROM t_ulk_stat WHERE usr_id = '$usr_id' ORDER by sta_date ASC";

	if ($rows = DBQueryAndFetchRows($query)) {
		for ( $idx = 0 ; $idx < count($rows) ; $idx++ ) {
			stripslashes($rows[$idx]['sta_info']);
		}
	}
	
	return $rows;
}

function BackendGetChangedPassword()
{
	$query = "SELECT COUNT(*) AS count FROM t_ulk_stat WHERE sta_action = ".ULK_ACTION_PASSCHANGED;

	$aff_rows = 0;
	$result = DBQueryAndFetchaRow($query,$aff_rows);

	return $result['count'];
}

function BackendLog($client,$cat,$nu,$info)
{
	global $gUseSyslog;
	global $gLogFile;
	global $gSyslogFacility;
	global $gAppName;

	$info = addslashes($info);
	$ipaddr = ip2long($client);

	$query = "INSERT INTO t_ulk_log (log_client,log_cat,log_nu,log_info,log_date) ".
				"VALUES ('$ipaddr','$cat','$nu','$info',NOW())";

	if ($gUseSyslog) {
		openlog($gAppName,LOG_PID,$gSyslogFacility);
		syslog(LOG_ERR,"$client: category=$cat, nu=$nu, info=[$info]");
		closelog();
	}

	if (!empty($gLogFile)) {
		error_log("$client: category=$cat, nu=$nu, info=[$info]\n",3,$gLogFile);
	}

	return DBExecute($query);
}

function BackendGetLog($startdate,$enddate,$client,$cat)
{
	$startdate = addslashes($startdate);
	$enddate = addslashes($enddate);
	$cat = addslashes($cat);

	$filter = "";
	if (!empty($client)) {
		$client = ip2long($client);
		$filter .= "log_client = '$client'";
	}
	if (!empty($startdate)) {
		if (!empty($filter)) $filter .= " AND ";
		$filter .= "log_date >= '$startdate'";
	}
	if (!empty($enddate)) {
		if (!empty($filter)) $filter .= " AND ";
		$filter .= "log_date <= '$enddate'";
	}
	if (!empty($cat)) {
		if (!empty($filter)) $filter .= " AND ";
		$filter .= "log_cat = '$cat'";
	}
	if (!empty($filter)) $filter = "WHERE ".$filter;

	$query = "SELECT DATE_FORMAT(log_date,'%y-%m-%d %H:%i:%s') as log_date,log_client,log_cat,log_nu,log_info ".
				" FROM t_ulk_log $filter ORDER BY log_date ASC";

	#echo $query;
	if ($rows = DBQueryAndFetchRows($query)) {
		for ( $idx = 0 ; $idx < count($rows) ; $idx++ ) {
			stripslashes($rows[$idx]['log_info']);
		}
	}
	
	return $rows;
}

function BackendDelLog($startdate,$enddate,$client,$cat)
{
	$startdate = addslashes($startdate);
	$enddate = addslashes($enddate);
	$cat = addslashes($cat);

	$filter = "";
	if (!empty($client)) {
		$client = ip2long($client);
		$filter .= "log_client = '$client'";
	}
	if (!empty($startdate)) {
		if (!empty($filter)) $filter .= " AND ";
		$filter .= "log_date >= '$startdate'";
	}
	if (!empty($enddate)) {
		if (!empty($filter)) $filter .= " AND ";
		$filter .= "log_date <= '$enddate'";
	}
	if (!empty($cat)) {
		if (!empty($filter)) $filter .= " AND ";
		$filter .= "log_cat = '$cat'";
	}
	if (!empty($filter)) $filter = "WHERE ".$filter;

	$query = "DELETE FROM t_ulk_log $filter";

	#echo $query;
	if (!DBExecute($query))
		return 0;

	return 1;
}

# ---------------------------------------------------------
# Session Management:
# ---------------------------------------------------------
function BackendGetSession($sid)
{
	$sid = addslashes($sid);

	$query = "SELECT usr_id,ini_session,DATE_FORMAT(ini_date,'%Y%m%d%H') AS ini_date ".
			" FROM t_ulk_init WHERE ini_session = '$sid'";

	$aff_rows = 0;
	return DBQueryAndFetchaRow($query,$aff_rows);
}

function BackendNotInitAccount(&$countok,&$countnotok)
{
	# Initialized user accounts have answers for the
	# administrative questions:

	$query = "SELECT COUNT(DISTINCT usr_id) AS countok FROM t_ulk_admanswer";
	$aff_rows = 0;
	$result = DBQueryAndFetchaRow($query,$aff_rows);

	$countok = $result['countok'];

	$countall = BackendGetUserCount();

	$countnotok = $countall - $countok;
}

function BackendGetTicketCount()
{
	$query = "SELECT COUNT(*) AS count FROM t_ulk_init";
	$aff_rows = 0;
	$result = DBQueryAndFetchaRow($query,$aff_rows);

	$countok = $result['count'];

	return $result['count'];
}

function BackendIsExpiredTicket($ticket)
{
	global $gTicketLifeTime;

	//$curdate = date("YmdH");
	$ini_date = $ticket['ini_date'];

	$curdate = time(NULL);
	$year = substr($ini_date,0,4);
	$month = substr($ini_date,4,2);
	$day = substr($ini_date,6,2);
	$hour = substr($ini_date,8,2);
	$ini_date = mktime($hour,0,0,$month,$day,$year);

	return $ini_date + $gTicketLifeTime*3600 < $curdate;
}

function BackendGetExpiredTicketCount()
{
	global $gTicketLifeTime;

	$curdate = date("YmdH");

	$query = "SELECT COUNT(*) AS count FROM t_ulk_init ".
			"WHERE DATE_ADD(ini_date,INTERVAL $gTicketLifeTime HOUR) < $curdate";
	$aff_rows = 0;
	$result = DBQueryAndFetchaRow($query,$aff_rows);

	$countok = $result['count'];

	return $result['count'];
}

function BackendPurgeExpiredTickets()
{
	global $gTicketLifeTime;

	$curdate = date("YmdH");

	$query = "DELETE FROM t_ulk_init ".
			"WHERE ROUND(ini_date/10000) + $gTicketLifeTime < $curdate";

	if (!DBExecute($query))
		return 0;

	return 1;
}

function BackendAddTicket($usr_id)
{
	$usr_id = addslashes($usr_id);

	if (!($user = BackendGetUser($usr_id)))
		return 0;

	srand(time());	# mandatory with PHP < 4.2.0
	$sid = md5($user['usr_name'].rand());
	
	$query = "INSERT INTO t_ulk_init (usr_id,ini_date,ini_session) VALUES ('$usr_id',NOW(),'$sid')";

	if (!DBExecute($query))
		return 0;

	return $sid;
}

function BackendGetTicket($usr_id)
{
	$usr_id = addslashes($usr_id);

	$query = "SELECT * FROM t_ulk_init WHERE usr_id = '$usr_id'";

	$aff_rows = 0;
	return DBQueryAndFetchaRow($query,$aff_rows);
}

function BackendDelTicket($usr_id)
{
	$usr_id = addslashes($usr_id);

	$query = "DELETE FROM t_ulk_init WHERE usr_id = '$usr_id'";
	
	if (!DBExecute($query))
		return 0;

	return 1;
}

# ---------------------------------------------------------
# User Management:
# ---------------------------------------------------------
function BackendGetAllUserID()
{
	$query = "SELECT usr_id FROM t_ulk_user";

	$result = DBQueryAndFetchRows($query);

	return $result;
}

function BackendGetUserCount()
{
	$query = "SELECT COUNT(*) AS COUNT FROM t_ulk_user";

	$aff_rows = 0;
	$row = DBQueryAndFetchaRow($query,$aff_rows);

	return $row['COUNT'];
}

function BackendIsUserAccountInit($usr_id)
{
	/* Please note, that you can also use the
 	 * usr_init column of t_ulk_user table
	 */
	$usr_id = addslashes($usr_id);
	$rows = BackendGetAdminAnswers($usr_id);

	if ($rows = 0 || count($rows) == 0)
		return 0;

	return 1;
}

function BackendSetUserAccountInit($usr_id)
{
	$usr_id = addslashes($usr_id);

	$query = "UPDATE t_ulk_user SET usr_init = 1 WHERE usr_id = '$usr_id'";

	if (!($result = DBExecute($query))) {
		return 0;
	}

	return 1;
}

function BackendGetUserSlice($start,$limit,$crit = "",$way = "")
{
	$crit = addslashes($crit);
	$way = addslashes($way);
	if (empty($crit)) $crit = "usr_name";
	if (empty($way)) $way = "ASC";

	# This syntax is MySQL and PostgreSQL compatible:
	# First row offset is 0
	$query = "SELECT * FROM t_ulk_user ORDER BY $crit $way LIMIT $limit OFFSET $start";

	if (($rows = DBQueryAndFetchRows($query))) {
		for ( $idx = 0 ; $idx < count($rows) ; $idx++ ) {
			StripUser($rows[$idx]);
		}
	}

	return $rows;
}

function BackendGetUser($uid)
{
	$query = "SELECT * from t_ulk_user WHERE usr_id = '$uid'";

	$aff_rows = 0;
	if ($row = DBQueryAndFetchaRow($query,$aff_rows)) {
		StripUser($row);
	}

	return $row;
}

function BackendGetUserByName($name)
{
	$name = addslashes($name);

	$query = "SELECT * FROM t_ulk_user WHERE usr_name = '$name'";

	$aff_rows = 0;
	if ($row = DBQueryAndFetchaRow($query,$aff_rows)) {
		StripUser($row);
	}

	return $row;
}

function BackendGetUserLike($name)
{
	$name = addslashes($name);

	$query = "SELECT * FROM t_ulk_user WHERE usr_name LIKE '$name' ORDER BY usr_name ASC";

	if ($rows = DBQueryAndFetchRows($query)) {
		for ( $idx = 0 ; $idx < count($rows) ; $idx++ ) {
			StripUser($rows[$idx]);
		}
	}

	return $rows;
}

function StripUser(&$user)
{
	$user['usr_name'] = stripslashes($user['usr_name']);
	$user['usr_fullname'] = stripslashes($user['usr_fullname']);
	$user['usr_email'] = stripslashes($user['usr_email']);
	$user['usr_accinfo'] = stripslashes($user['usr_accinfo']);
	$user['usr_lang'] = stripslashes($user['usr_lang']);
}

# We guess TABLE LOCK is not necessary...
function BackendNewUser($name,$fullname,$lang,$info,$email)
{
	$name = addslashes($name);
	$fullname = addslashes($fullname);
	$lang = addslashes($lang);
	$info = addslashes($info);
	$email = addslashes($email);

	$query = "SELECT MAX(usr_id) AS maxid FROM t_ulk_user";
	$aff_rows = 0;
	if (!($result = DBQueryAndFetchaRow($query,$aff_rows))) {
		return 0;
	}

	$usr_id = $result['maxid'] + 1;

	$query = "INSERT INTO t_ulk_user (usr_id,usr_name,usr_fullname,usr_email,usr_lang,usr_accinfo) ".
			"VALUES ('$usr_id','$name','$fullname','$email','$lang','$info')";

	if (!($result = DBExecute($query))) {
		return 0;
	}

	return $usr_id;
}

function BackendModifyUser($uid,$fullname,$lang,$info,$email)
{
	$uid = addslashes($uid);
	$fullname = addslashes($fullname);
	$lang = addslashes($lang);
	$info = addslashes($info);
	$email = addslashes($email);

	$query = "UPDATE t_ulk_user SET usr_lang = '$lang', usr_accinfo = '$info', ".
			"usr_fullname = '$fullname', usr_email = '$email' WHERE usr_id = '$uid'";
	if (!($result = DBExecute($query))) {
		return 0;
	}

	return 1;
}

function BackendDelUser($usr_id)
{
	$usr_id = addslashes($usr_id);

	$query = "DELETE FROM t_ulk_usraccount WHERE usr_id = '$usr_id'";
	$result = DBExecute($query);

	$query = "DELETE FROM t_ulk_user WHERE usr_id = '$usr_id'";
	if (!($result = DBExecute($query))) {
		return 0;
	}

	return 1;
}

# ---------------------------------------------------------
# User Account Management:
# ---------------------------------------------------------
function BackendGetAllUserAccount($usr_id)
{
	$usr_id = addslashes($usr_id);

	$query = "SELECT t_ulk_usraccount.*,t_ulk_genaccount.act_name ".
			"FROM t_ulk_usraccount,t_ulk_genaccount WHERE ".
			"t_ulk_usraccount.usr_id = '$usr_id' AND t_ulk_genaccount.act_id = t_ulk_usraccount.act_id";

	return DBQueryAndFetchRows($query);
}

function BackendAddUserAccount($usr_id,$act_id)
{
	$usr_id = addslashes($usr_id);
	$act_id = addslashes($act_id);

	$query = "INSERT INTO t_ulk_usraccount (usr_id,act_id) VALUES ('$usr_id','$act_id')";

	if (!($result = DBExecute($query))) {
		return 0;
	}

	return DBAffectedRows();
}

function BackendModifyUserAccount($usr_id,$accounts)
{
	$usr_id = addslashes($usr_id);

	if (!($genaccount = BackendGetAllGenAccount())) {
		return 0;
	}

	$query = "DELETE FROM t_ulk_usraccount WHERE usr_id = '$usr_id'";

	if (!($result = DBExecute($query))) {
		return 0;
	}

	foreach ($accounts as $acc) {
		for ( $idx = 0 ; $idx < count($genaccount) ; $idx++ ) {
			if ($acc == $genaccount[$idx]['act_name']) {
				BackendAddUserAccount($usr_id,$genaccount[$idx]['act_id']);
				break;
			}
		}
	}

	return 1;
}

# ---------------------------------------------------------
# Answers and Queries Management:
# ---------------------------------------------------------
function BackendGetAdminQueries($lang)
{
	$query = "SELECT * FROM t_ulk_admquery WHERE adq_lang = '$lang' ORDER BY adq_id ASC";

	$rows = DBQueryAndFetchRows($query);
	for ( $idx = 0 ; $idx < count($rows) ; $idx++) {
		$rows[$idx]['adq_text'] = stripslashes($rows[$idx]['adq_text']);
	}
	return $rows;
}

function BackendAddAdminQuery($lang,$q)
{
	$q = addslashes($q);

	$query = "SELECT MAX(adq_id) AS maxid FROM t_ulk_admquery";
	$aff_rows = 0;
	if (!($result = DBQueryAndFetchaRow($query,$aff_rows))) {
		return 0;
	}

	$adq_id = $result['maxid'] + 1;

	$query = "INSERT INTO t_ulk_admquery (adq_id,adq_lang,adq_text) ".
			"VALUES ('$adq_id','$lang','$q')";

	if (!($result = DBExecute($query))) {
		return 0;
	}

	return $adq_id;
}

function BackendModAdminQuery($lang,$id,$text)
{
	$lang = addslashes($lang);
	$id = addslashes($id);
	$text = addslashes($text);

	$query = "UPDATE t_ulk_admquery SET adq_text = '$text' WHERE adq_lang = '$lang' AND adq_id = '$id'";

	$result = DBExecute($query);

	return $result;
}

function BackendDelAdminQuery($lang,$id)
{
	$lang = addslashes($lang);
	$id = addslashes($id);

	$query = "DELETE FROM t_ulk_admquery WHERE adq_lang = '$lang' AND adq_id = '$id'";

	if (!($result = DBExecute($query))) 
		return 0;
	
	return DBAffectedRows();
}

function BackendGetAdminAnswers($usr_id)
{
	$query = "SELECT * FROM t_ulk_admanswer WHERE usr_id = '$usr_id' ORDER BY adq_id ASC";

	$rows = DBQueryAndFetchRows($query);
	for ( $idx = 0 ; $idx < count($rows) ; $idx++) {
		$rows[$idx]['adq_answer'] = stripslashes($rows[$idx]['adq_answer']);
	}

	return $rows;
}

function BackendGetUserQueries($usr_id)
{
	$query = "SELECT * FROM t_ulk_usrquery WHERE usr_id = '$usr_id' ORDER BY usq_id ASC";

	$rows = DBQueryAndFetchRows($query);
	for ( $idx = 0 ; $idx < count($rows) ; $idx++) {
		$rows[$idx]['usq_answer'] = stripslashes($rows[$idx]['usq_answer']);
		$rows[$idx]['usq_query'] = stripslashes($rows[$idx]['usq_query']);
	}
	
	return $rows;
}

function BackendUpdateAdminAnswers($usr_id,&$admanswer)
{
	for ( $idx = 0 ; $idx < count($admanswer) ; $idx++ ) {
		BackendSetAdminAnswer($usr_id,$idx,$admanswer[$idx]);
	}
}

function BackendUpdateUserAnswers($usr_id,&$usrquery,&$usranswer)
{
	for ( $idx = 0 ; $idx < count($usranswer) ; $idx++ ) {
		BackendSetUserAnswer($usr_id,$idx,$usrquery[$idx],$usranswer[$idx]);
	}
}

function BackendSetAdminAnswer($usr_id,$adq_id,$answer)
{
	$answer = addslashes($answer);

	# use a REPLACE with MySQL !!!!
	$query = "REPLACE INTO t_ulk_admanswer (adq_answer,usr_id,adq_id) ".
			"VALUES ('$answer','$usr_id','$adq_id')";

	$result = DBExecute($query);

	return $result;
}

function BackendSetUserAnswer($usr_id,$usq_id,$uq,$ua)
{
	$ua = addslashes($ua);
	$uq = addslashes($uq);

	# use a REPLACE with MySQL !!!!
	$query = "REPLACE INTO t_ulk_usrquery (usq_answer,usq_query,usr_id,usq_id) ".
			"VALUES ('$ua','$uq','$usr_id','$usq_id')";

	$result = DBExecute($query);

	return $result;
}

# ---------------------------------------------------------
# Generic Account Management:
# ---------------------------------------------------------
function BackendGetAllGenAccount()
{
	$query = "SELECT * FROM t_ulk_genaccount ORDER BY act_name ASC";

	$rows = DBQueryAndFetchRows($query);
	for ( $idx = 0 ; $idx < count($rows) ; $idx++) {
		StripGenAccount($rows[$idx]);
	}

	return $rows;
}

function BackendGetGenAccount($act_id)
{
	$act_id = addslashes($act_id);
	$query = "SELECT * from t_ulk_genaccount WHERE act_id = '$act_id'";

	$aff_rows = 0;
	if (!($row = DBQueryAndFetchaRow($query,$aff_rows)))
		return 0;

	StripGenAccount($row);

	return $row;
}

function StripGenAccount(&$account)
{
	$account['act_name'] = stripslashes($account['act_name']);
	$account['act_desc'] = stripslashes($account['act_desc']);
	$account['act_script'] = stripslashes($account['act_script']);
}

function BackendDelGenAccount($act_id) 
{
	$act_id = addslashes($act_id);

	$query = "DELETE FROM t_ulk_genaccount WHERE act_id = '$act_id'";

	if (!($result = DBExecute($query))) 
		return 0;
	
	return DBAffectedRows();
}

# We guess TABLE LOCK is not necessary...
function BackendNewGenAccount($act_name,$act_desc,$act_script)
{
	$act_name = addslashes($act_name);
	$act_desc = addslashes($act_desc);
	$act_script = addslashes($act_script);

	$query = "SELECT MAX(act_id) AS maxid FROM t_ulk_genaccount";
	$aff_rows = 0;
	if (!($result = DBQueryAndFetchaRow($query,$aff_rows))) {
		return 0;
	}

	$act_id = $result['maxid'] + 1;

	$query = "INSERT INTO t_ulk_genaccount (act_id,act_name,act_desc,act_script) ".
			"VALUES ('$act_id','$act_name','$act_desc','$act_script')";

	if (!($result = DBExecute($query))) {
		return 0;
	}

	return $act_id;
}

function BackendSetGenAccount($act_id,$act_name,$act_desc,$act_script)
{
	$act_id = addslashes($act_id);
	$act_name = addslashes($act_name);
	$act_desc = addslashes($act_desc);
	$act_script = addslashes($act_script);

	$query = "UPDATE t_ulk_genaccount SET act_name = '$act_name', act_desc = '$act_desc', ".
			"act_script = '$act_script' WHERE act_id = '$act_id'";

	$result = DBExecute($query);

	return $result;
}
?>
