<?php
#
# There are two ways to change the User Preferences:
#
# 1) after identifying oneself
# 2) by giving a valid session
#

include_once "../../conf/include.inc.php";
include_once "locale.inc.php";
include_once "backend.inc.php";

$errorPage = "user.html";
$gMSG = "";
$lang = $gUsrLangDefault;

session_start();
if (isset($_SESSION['lang'])) {
	if (in_array($_SESSION['lang'],$gUsrLangSupported)) {
		$lang = $_SESSION['lang'];
	}
	else {
		unset($_SESSION['lang']);
	}
}

if (!isset($_SESSION['ctxt'])) {
	if (!isset($_REQUEST['sessionid'])) {
		#$gMSG = _("Session ID manquant");
		BackendLog($_SERVER["REMOTE_ADDR"],ULK_TYPE_ERROR,ULK_ERR_NOSID,$gMSG);
		$origin = "userprefs";
		$_SESSION['origin'] = $origin;
		PageUserOutput("pwdRecovery.html",$lang,$ctxt);
		die;
	}

	$session = BackendGetSession($_REQUEST['sessionid']);
	if (!$session) {
		$gMSG = _("Ticket inexistant");
		BackendLog($_SERVER["REMOTE_ADDR"],ULK_TYPE_ERROR,ULK_ERR_BADSID,$gMSG);
		PageUserOutput($errorPage,$lang,$ctxt);
		die;
	}

	$ctxt['user'] = BackendGetUser($session['usr_id']);
	$usr_id = $ctxt['user']['usr_id'];
	$usr_name = $ctxt['user']['usr_name'];

	# Check if the ticket has not expired:
	if (BackendIsExpiredTicket($session)) {
		$gMSG = _("Le Ticket a expir&eacute;, contactez l'Administrateur");
		BackendLog($_SERVER["REMOTE_ADDR"],ULK_TYPE_ERROR,ULK_ERR_OLDTICKET,$gMSG);
		$info = _("Le ticket de l'utilisateur $usr_name ($usr_id) a expire");
		UnlockMail("Ticket expire",$info);
		PageUserOutput($errorPage,$ctxt['user']['usr_lang'],$ctxt);
		die;
	}

	# Session starts here:
	$_SESSION['ctxt'] = $ctxt;
}
else {
	$ctxt = $_SESSION['ctxt'];
}

#phpinfo();

$userLang = $ctxt['user']['usr_lang'];

$ctxt['admqry'] = BackendGetAdminQueries($userLang);

# Check the user has filled all the required fields:
$ok = 1;
for ( $idx = 0 ; $idx < count($ctxt['admqry']) ; $idx++ ) {
	if (empty($_REQUEST['admanswer'])) {
		#echo "Admin answer $idx is empty<br>\n";
		$ok = 0;
	}
}

# At least $gMinUsrQueries must have been filled:
for ( $idx = 0 ; $idx < $gMinUsrQueries ; $idx++ ) {
	if (empty($_REQUEST['usrquery'][$idx]) ||
	    empty($_REQUEST['usranswer'][$idx])) {
		#echo "User Query or Answer $idx is empty<br>\n";
		$ok = 0;
	}
}

# Update the answers & usrqueries:

if ($ok) {
	BackendUpdateAdminAnswers($ctxt['user']['usr_id'],$_REQUEST['admanswer']);
	BackendUpdateUserAnswers($ctxt['user']['usr_id'],$_REQUEST['usrquery'],$_REQUEST['usranswer']);
	BackendAddStat($ctxt['user']['usr_id'],$_SERVER['REMOTE_ADDR'],
			ULK_ACTION_INFOCHANGED,_("Pr&eacute;f&eacute;rences modifi&eacute;es"));
	$gMSG = _("Les modifications ont &eacute;t&eacute; effectu&eacute;es");

	BackendDelTicket($ctxt['user']['usr_id']);
	BackendSetUserAccountInit($ctxt['user']['usr_id']);
}

$ctxt['admqry'] = BackendGetAdminQueries($userLang);
$ctxt['usrqry'] = BackendGetUserQueries($ctxt['user']['usr_id']);
$ctxt['admans'] = BackendGetAdminAnswers($ctxt['user']['usr_id']);
# assert $ctxt['user'] not null

if (!$ok && isset($_REQUEST['usranswer']) && isset($_REQUEST['admanswer'])) {
	for ( $idx = 0 ; $idx < count($_REQUEST['usranswer']) ; $idx++ ) {
		$ctxt['usrqry'][$idx]['usq_query'] = $_REQUEST['usrquery'][$idx];
		$ctxt['usrqry'][$idx]['usq_answer'] = $_REQUEST['usranswer'][$idx];
	}
	for ( $idx = 0 ; $idx < count($_REQUEST['admanswer']) ; $idx++ ) {
		$ctxt['admans'][$idx]['adq_answer'] = $_REQUEST['admanswer'][$idx];
	}
}

#print_r($ctxt);

PageUserOutput("userPrefs.html",$userLang,$ctxt);
?>
