<?php
#
# This script creates a new user account in Unlockator Database.
# It can (must ?) be called at system account creation.
#
# Requires PHP 4.3.0+
#
# TODO: this script has not been ported under Windows
#	the "at" command should be like the one in ticketinit2.php
#
include_once "../../conf/include.inc.php";
include_once "../../mmi/common/backend.inc.php";

$delay = 60;	/* tickets are sent in 60 minutes */

# since getopt() is not supported under Windows, we use
# our own function:
#$opt = getopt("u:f:e:i:l:a:m:t");
include_once "../getopt.inc.php";
$opt = MyGetopt($argc,$argv);

if (!isset($opt['u']) || empty($opt['u'])) {
	echo "The username (option -u) is missing\n";
	usage();
}
if (!isset($opt['f']) || empty($opt['f'])) {
	echo "The user fullname (option -f) is missing\n";
	usage();
}
if (!isset($opt['e']) || empty($opt['e'])) {
	echo "The user email address (option -e) is missing\n";
	usage();
}
if (!isset($opt['i']) || empty($opt['i'])) {
	echo "The user information (option -i) is missing\n";
	usage();
}
if (!isset($opt['l']) || empty($opt['l'])) {
	echo "The user language (option -l) is missing\n";
	usage();
}
if (!isset($opt['a']) || empty($opt['a'])) {
	echo "The user account list (option -a) is missing\n";
	usage();
}
if (!isset($opt['m']) || empty($opt['m'])) {
	echo "The calling process mark (option -m) is missing\n";
	usage();
}

# The account list must be valid:
$genaccount = explode(",",$opt['a']);
$genaccid = array();

if (!($acclist = BackendGetAllGenAccount())) {
	echo "The Account list is empty !\n";
	usage();
}

foreach ($genaccount as $account) {
	$found = false;
	foreach ($acclist as $acc) {
		if ($acc['act_name'] == $account) {
			$found = true;
			$genaccid[] = $acc['act_id'];
			break;
		}
	}
	if (!$found) {
		echo "Account '$account' not in Database\n";
		usage();
	}
}

# Check the user name does not already exists:
if ($usr = BackendGetUserByName($opt['u'])) {
	echo "User '".$opt['u']."' already exists\n";
	usage();
}

# Insert the new user and the associated accounts:
if ($usr_id = BackendNewUser($opt['u'],$opt['f'],$opt['l'],$opt['i'],$opt['e'])) {
	foreach ($genaccid as $act_id) {
		BackendAddUserAccount($usr_id,$act_id);
	}
}

echo "Account for user '".$opt['u']."' successfully created !\n";

# Now send a ticket in 1 hour (we wait for the mailbox to be created):
# Build the "at" command:
$curtime = time() + 60 * $delay;
$t = localtime($curtime);
$hour = $t[2]; $min = $t[1]; 
$month = $t[4] + 1; $day = $t[3]; $year = $t[5] + 1900;
if ($day < 10) $day = "0".$day;
if ($month < 10) $month = "0".$month;
if ($hour < 10) $hour = "0".$hour;
if ($min < 10) $min = "0".$min;

$arg = "-u \"".$opt['u']."\"";

$cmd = "at $hour$min $month$day$year <<EOF\ncd ..\n".$gPHPPath." -q ticketinit.php $arg\nEOF";                
echo $cmd;
system($cmd,$retval);
echo "Ticket scheduled...\n";

exit(0);

function usage()
{
	echo "\n";
	echo "Syntax: php account_create.php -m mark -u user -i info -l lang -e email -f fullname -a account-list [-t]\n\n";
	echo "where:\n";
	echo "\tm: calling process mark (for logging)\n";
	echo "\tu: user account name\n";
	echo "\ti: user information\n";
	echo "\tl: user preferred language\n";
	echo "\te: user email address\n";
	echo "\tf: user full name\n";
	echo "\ta: user account list (unix,windows,app1....)\n";
	echo "\tt: generate a ticket\n";
	echo "\n";
	exit(1);
}

# EOF
?>
