/*
 * ===========================================================================
 * Fichier: parm.h
 * ---------------------------------------------------------------------------
 * Date:	04/02/06
 * Auteur :	J.Delamarche
 * Version:	1.0
 * ---------------------------------------------------------------------------
 * Les fonctions de ce module permettent de grer l'interface avec la base
 * de registre qui stocke les paramtres externes de l'application.
 * ===========================================================================
 */
#ifndef _include_parm_h_
#define _include_parm_h_

#include <windows.h>

#define _MAX_STRING_	256

/*
 * Cette structure contient les paramtres externes:
 */
typedef struct {
	BOOL		m_active;						/* doit tre TRUE pour activer la DLL ! */
	BOOL		m_debug;						/* mode debug */
	TCHAR		m_szExternalCommand[MAX_PATH];	/* command executed to create a new unlockator account */
	TCHAR		m_szSharedSecret[MAX_PATH];		/* secret with the remote winuser.php script */

	void		(*m_log)(WORD wType, const TCHAR *szFormat,...);	/* fonction de log */
} lsParm;

extern DWORD GetParms(lsParm *,void (*logFunc)(WORD wType, const TCHAR *szFormat, ...));

#endif

 /* EOF */