/*
 * ===========================================================================
 * Fichier: process.c
 * ---------------------------------------------------------------------------
 * Date:	04/02/06
 * Auteur :	J.Delamarche
 * Version:	1.0
 *
 * ---------------------------------------------------------------------------
 *
 * Gre la commande externe
 *
 * ===========================================================================
 */
#include <windows.h>
#include <string.h>
#include <tchar.h>
#include "parm.h"
#include "log.h"
#include "process.h"
#include "md5api.h"

DWORD Start(lsParm *parm, const TCHAR *szUsername)
{
    STARTUPINFO         si;
    PROCESS_INFORMATION pi;
	DWORD				dwErrorCode;
    TCHAR zCmdLine[MAX_PATH];    // Because CreateProcess() modifies its second argument!!
	TCHAR bufftohash[MAX_PATH];
	char *md5value;

    memset(&si, 0, sizeof(si));
    si.cb = sizeof(si);

	lstrcpyn(bufftohash,szUsername,MAX_PATH-lstrlen(parm->m_szSharedSecret)-1);
	bufftohash[MAX_PATH-1] = _T('\0');
	lstrcat(bufftohash,parm->m_szSharedSecret);
	md5value = CalcMD5FromString(bufftohash);

    lstrcpyn(zCmdLine,parm->m_szExternalCommand,MAX_PATH-1-lstrlen(szUsername)-1-lstrlen(md5value)-1);
	zCmdLine[MAX_PATH-1] = _T('\0');
	lstrcat(zCmdLine," ");
	lstrcat(zCmdLine,szUsername);
	lstrcat(zCmdLine," ");
	lstrcat(zCmdLine,md5value);

	if (parm->m_debug)
		Log(EVENTLOG_INFORMATION_TYPE,"Start: %s",zCmdLine);

    if (CreateProcess(NULL, zCmdLine, NULL, NULL, FALSE,
                      CREATE_DEFAULT_ERROR_MODE|CREATE_NEW_CONSOLE,
                      NULL, NULL, &si, &pi) == FALSE)
    {
        LPVOID lpMsgBuf;
        dwErrorCode = GetLastError() ;
        FormatMessage(  FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
                        NULL,
                        dwErrorCode,
                        MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
                        (LPTSTR) &lpMsgBuf,
                        0,
                        NULL );
		Log(EVENTLOG_ERROR_TYPE,_T("CreateProcess a chou:"));
		Log(EVENTLOG_ERROR_TYPE,(TCHAR *)lpMsgBuf);
        LocalFree(lpMsgBuf) ;
	    return dwErrorCode;
    }

	if (parm->m_debug)
		Log(EVENTLOG_INFORMATION_TYPE,"Command launched successfully");

	CloseHandle(pi.hThread);
	CloseHandle(pi.hProcess);
    dwErrorCode = 0 ;

    return dwErrorCode;
}
